#define HELP       1                    /* Display help screen */
#define OPEN       10                   /* Error opening file */
#define CLOSE      20                   /* Error closing file */
#define READ       30                   /* Error reading file */
#define WRITE      40                   /* Error writing file */
#define SEEK       50                   /* Error seeking in file */
#define MEMORY     60                   /* Error allocating memory */

#ifndef USAGE
 #define USAGE "Help not available\n"
#endif

void Error( int ErrorLevel, int Line, char * File );

void
Error( int ErrorLevel, int Line, char * File )
{
    switch( ErrorLevel )
    {
        case HELP:   fprintf( stderr, USAGE );
                     break;
    
        case OPEN:   fprintf( stderr, "ERROR (%d): Cannot open: %s\n",
                             Line, File );
                     break;
    
        case CLOSE:  fprintf( stderr, "ERROR (%d): Cannot close %s\n",
                             Line, File );
                     break;
    
        case READ:   fprintf( stderr, "ERROR (%d): Cannot read %s\n",
                             Line, File );
                     break;
   
        case WRITE:  fprintf( stderr, "ERROR (%d): Cannot write %s\n",
                             Line, File );
                     break;
 
        case SEEK:   fprintf( stderr, "ERROR (%d): Seek error in %s\n",
                              Line, File );
                     break;

        case MEMORY: fprintf( stderr, "ERROR (%d): Cannot allocate memory\n",
                             Line );
                     break;

        default:     fprintf( stderr, "ERROR (%d): Invalid instruction\n",
                             Line );
    }
    exit( ErrorLevel );
}

